# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *
import dataclasses

V__DJUNCT_DWI_SELECTOR_METADATA = Metadata(
    id="322cd55e91869cfd3befcc11394010a6d10dddc6.boutiques",
    name="@djunct_dwi_selector",
    package="afni",
    container_image_tag="afni/afni_make_build:AFNI_24.2.06",
)


class VDjunctDwiSelectorOutputs(typing.NamedTuple):
    """
    Output object returned when calling `v__djunct_dwi_selector(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""
    outfile: OutputPathType
    """The main output file"""


def v__djunct_dwi_selector(
    dwi: InputPathType,
    png: InputPathType,
    outfile: str,
    runner: Runner | None = None,
) -> VDjunctDwiSelectorOutputs:
    """
    Selects DWI data and creates a representative image.
    
    Author: AFNI Developers
    
    URL: https://afni.nimh.nih.gov/
    
    Args:
        dwi: Input DWI file.
        png: Output PNG image.
        outfile: Path to the output file.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `VDjunctDwiSelectorOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(V__DJUNCT_DWI_SELECTOR_METADATA)
    cargs = []
    cargs.append("@djunct_dwi_selector.tcsh")
    cargs.append(execution.input_file(dwi))
    cargs.append(execution.input_file(png))
    cargs.append(outfile)
    ret = VDjunctDwiSelectorOutputs(
        root=execution.output_file("."),
        outfile=execution.output_file(outfile),
    )
    execution.run(cargs)
    return ret


__all__ = [
    "VDjunctDwiSelectorOutputs",
    "V__DJUNCT_DWI_SELECTOR_METADATA",
    "v__djunct_dwi_selector",
]
