# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *
import dataclasses

MORPH_SUBJECT_LH_METADATA = Metadata(
    id="da06f833976d33a0c94b485e6e21f58bc7a8916f.boutiques",
    name="morph_subject-lh",
    package="freesurfer",
    container_image_tag="freesurfer/freesurfer:7.4.1",
)


class MorphSubjectLhOutputs(typing.NamedTuple):
    """
    Output object returned when calling `morph_subject_lh(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""


def morph_subject_lh(
    subject_id: str,
    runner: Runner | None = None,
) -> MorphSubjectLhOutputs:
    """
    A tool for morphing subject's left hemisphere.
    
    Author: FreeSurfer Developers
    
    URL: https://github.com/freesurfer/freesurfer
    
    Args:
        subject_id: Subject ID.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `MorphSubjectLhOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(MORPH_SUBJECT_LH_METADATA)
    cargs = []
    cargs.extend([
        "-lh",
        "morph_subject" + subject_id
    ])
    ret = MorphSubjectLhOutputs(
        root=execution.output_file("."),
    )
    execution.run(cargs)
    return ret


__all__ = [
    "MORPH_SUBJECT_LH_METADATA",
    "MorphSubjectLhOutputs",
    "morph_subject_lh",
]
