# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *
import dataclasses

RENORMALIZE_T1_SUBJECT_METADATA = Metadata(
    id="fd1b560cfb5855fbdac004ecaa45cd6e0aa37abf.boutiques",
    name="renormalize_T1_subject",
    package="freesurfer",
    container_image_tag="freesurfer/freesurfer:7.4.1",
)


class RenormalizeT1SubjectOutputs(typing.NamedTuple):
    """
    Output object returned when calling `renormalize_t1_subject(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""


def renormalize_t1_subject(
    subject_dir: str,
    runner: Runner | None = None,
) -> RenormalizeT1SubjectOutputs:
    """
    Renormalize T1 subject images using FreeSurfer scripts.
    
    Author: FreeSurfer Developers
    
    URL: https://github.com/freesurfer/freesurfer
    
    Args:
        subject_dir: Directory of the subject containing T1 images to\
            renormalize.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `RenormalizeT1SubjectOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(RENORMALIZE_T1_SUBJECT_METADATA)
    cargs = []
    cargs.append("renormalize_T1_subject")
    cargs.append(subject_dir)
    ret = RenormalizeT1SubjectOutputs(
        root=execution.output_file("."),
    )
    execution.run(cargs)
    return ret


__all__ = [
    "RENORMALIZE_T1_SUBJECT_METADATA",
    "RenormalizeT1SubjectOutputs",
    "renormalize_t1_subject",
]
