# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *
import dataclasses

RUN_SEGMENT_SUBJECT_T1_AUTO_ESTIMATE_ALVEUS_ML_SH_METADATA = Metadata(
    id="4f9a46fb43606ac0251e70e49508d55ff638b63c.boutiques",
    name="run_segmentSubjectT1_autoEstimateAlveusML.sh",
    package="freesurfer",
    container_image_tag="freesurfer/freesurfer:7.4.1",
)


class RunSegmentSubjectT1AutoEstimateAlveusMlShOutputs(typing.NamedTuple):
    """
    Output object returned when calling `run_segment_subject_t1_auto_estimate_alveus_ml_sh(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""


def run_segment_subject_t1_auto_estimate_alveus_ml_sh(
    deployed_mcr_root: str,
    additional_args: str | None = None,
    runner: Runner | None = None,
) -> RunSegmentSubjectT1AutoEstimateAlveusMlShOutputs:
    """
    A script to automatically estimate Alveus using machine learning with the given
    subject T1 image.
    
    Author: FreeSurfer Developers
    
    URL: https://github.com/freesurfer/freesurfer
    
    Args:
        deployed_mcr_root: The root directory of the deployed MATLAB Runtime.
        additional_args: Additional arguments for the script.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `RunSegmentSubjectT1AutoEstimateAlveusMlShOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(RUN_SEGMENT_SUBJECT_T1_AUTO_ESTIMATE_ALVEUS_ML_SH_METADATA)
    cargs = []
    cargs.append("run_segmentSubjectT1_autoEstimateAlveusML.sh")
    cargs.append(deployed_mcr_root)
    if additional_args is not None:
        cargs.append(additional_args)
    ret = RunSegmentSubjectT1AutoEstimateAlveusMlShOutputs(
        root=execution.output_file("."),
    )
    execution.run(cargs)
    return ret


__all__ = [
    "RUN_SEGMENT_SUBJECT_T1_AUTO_ESTIMATE_ALVEUS_ML_SH_METADATA",
    "RunSegmentSubjectT1AutoEstimateAlveusMlShOutputs",
    "run_segment_subject_t1_auto_estimate_alveus_ml_sh",
]
