# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *
import dataclasses

RUN_SEGMENT_SUBJECT_T1_T2_AUTO_ESTIMATE_ALVEUS_ML_SH_METADATA = Metadata(
    id="bf2051c733cf330a51f7a8fb68683e56389c2d7f.boutiques",
    name="run_segmentSubjectT1T2_autoEstimateAlveusML.sh",
    package="freesurfer",
    container_image_tag="freesurfer/freesurfer:7.4.1",
)


class RunSegmentSubjectT1T2AutoEstimateAlveusMlShOutputs(typing.NamedTuple):
    """
    Output object returned when calling `run_segment_subject_t1_t2_auto_estimate_alveus_ml_sh(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""


def run_segment_subject_t1_t2_auto_estimate_alveus_ml_sh(
    deployed_mcr_root: str,
    additional_args: str | None = None,
    runner: Runner | None = None,
) -> RunSegmentSubjectT1T2AutoEstimateAlveusMlShOutputs:
    """
    Automated segmentation tool for T1 and T2 weighted images to estimate the
    Alveus.
    
    Author: FreeSurfer Developers
    
    URL: https://github.com/freesurfer/freesurfer
    
    Args:
        deployed_mcr_root: Root directory for the deployed MATLAB Compiler\
            Runtime (MCR).
        additional_args: Additional command-line arguments for the underlying\
            processing tool.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `RunSegmentSubjectT1T2AutoEstimateAlveusMlShOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(RUN_SEGMENT_SUBJECT_T1_T2_AUTO_ESTIMATE_ALVEUS_ML_SH_METADATA)
    cargs = []
    cargs.append("run_segmentSubjectT1T2_autoEstimateAlveusML.sh")
    cargs.append(deployed_mcr_root)
    if additional_args is not None:
        cargs.append(additional_args)
    ret = RunSegmentSubjectT1T2AutoEstimateAlveusMlShOutputs(
        root=execution.output_file("."),
    )
    execution.run(cargs)
    return ret


__all__ = [
    "RUN_SEGMENT_SUBJECT_T1_T2_AUTO_ESTIMATE_ALVEUS_ML_SH_METADATA",
    "RunSegmentSubjectT1T2AutoEstimateAlveusMlShOutputs",
    "run_segment_subject_t1_t2_auto_estimate_alveus_ml_sh",
]
