# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *
import dataclasses

APPLYTOPUP_METADATA = Metadata(
    id="28ab631a68595bc2447ad41e586fe5e30606d0a6.boutiques",
    name="applytopup",
    package="fsl",
    container_image_tag="brainlife/fsl:6.0.4-patched2",
)


class ApplytopupOutputs(typing.NamedTuple):
    """
    Output object returned when calling `applytopup(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""
    output_file: OutputPathType
    """The output warped image."""


def applytopup(
    imain: list[InputPathType],
    datain: InputPathType,
    inindex: list[str],
    topup: InputPathType,
    out: str,
    method: typing.Literal["jac", "lsr"] | None = None,
    interp: typing.Literal["trilinear", "spline"] | None = None,
    datatype: typing.Literal["char", "short", "int", "float", "double"] | None = None,
    verbose: bool = False,
    runner: Runner | None = None,
) -> ApplytopupOutputs:
    """
    applytopup applies corrections to images using the field estimates produced by
    topup.
    
    Author: FMRIB Analysis Group, University of Oxford
    
    URL: https://fsl.fmrib.ox.ac.uk/fsl/fslwiki
    
    Args:
        imain: Comma separated list of names of input image (to be corrected).
        datain: Name of text file with PE directions/times.
        inindex: Comma separated list of indices into --datain of the input\
            image (to be corrected).
        topup: Name of field/movements (from topup).
        out: Basename for output (warped) image.
        method: Use jacobian modulation (jac) or least-squares resampling\
            (lsr), default=lsr.
        interp: Interpolation method {trilinear, spline}, default=spline.
        datatype: Force output data type [char short int float double].
        verbose: Switch on diagnostic messages.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `ApplytopupOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(APPLYTOPUP_METADATA)
    cargs = []
    cargs.append("applytopup")
    cargs.append("--imain=" + ",".join([execution.input_file(f) for f in imain]))
    cargs.append("--datain=" + execution.input_file(datain))
    cargs.append("--inindex=" + ",".join(inindex))
    cargs.append("--topup=" + execution.input_file(topup, resolve_parent=True))
    cargs.append("--out=" + out)
    if method is not None:
        cargs.append("--method=" + method)
    if interp is not None:
        cargs.append("--interp=" + interp)
    if datatype is not None:
        cargs.append("--datatype=" + datatype)
    if verbose:
        cargs.append("--verbose")
    ret = ApplytopupOutputs(
        root=execution.output_file("."),
        output_file=execution.output_file(out),
    )
    execution.run(cargs)
    return ret


__all__ = [
    "APPLYTOPUP_METADATA",
    "ApplytopupOutputs",
    "applytopup",
]
