# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *
import dataclasses

CONNECTEDCOMP_METADATA = Metadata(
    id="7c1253e633254bef28f5556244da1e387dffc055.boutiques",
    name="connectedcomp",
    package="fsl",
    container_image_tag="brainlife/fsl:6.0.4-patched2",
)


class ConnectedcompOutputs(typing.NamedTuple):
    """
    Output object returned when calling `connectedcomp(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""
    outfile: OutputPathType | None
    """The output image volume"""


def connectedcomp(
    in_volume: InputPathType,
    output_volume: str | None = None,
    num_connect: int | None = None,
    runner: Runner | None = None,
) -> ConnectedcompOutputs:
    """
    Connected component analysis tool.
    
    Author: FMRIB Analysis Group, University of Oxford
    
    URL: https://fsl.fmrib.ox.ac.uk/fsl/fslwiki
    
    Args:
        in_volume: Input image volume.
        output_volume: Output image volume.
        num_connect: Number of connected components.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `ConnectedcompOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(CONNECTEDCOMP_METADATA)
    cargs = []
    cargs.append("connectedcomp")
    cargs.append(execution.input_file(in_volume))
    if output_volume is not None:
        cargs.append(output_volume)
    if num_connect is not None:
        cargs.append(str(num_connect))
    ret = ConnectedcompOutputs(
        root=execution.output_file("."),
        outfile=execution.output_file(output_volume) if (output_volume is not None) else None,
    )
    execution.run(cargs)
    return ret


__all__ = [
    "CONNECTEDCOMP_METADATA",
    "ConnectedcompOutputs",
    "connectedcomp",
]
